indexing

   description: "Class that covers the Posix file permission."
   usage: "You can set the permissions, call apply to make them permanent."

   author: "Berend de Boer"
   date: "$Date: Sat, 05 Aug 2000 14:28:49 +0200 $"
   revision: "$Revision: 1.1 $"

class 

   POSIX_PERMISSIONS_PATH

inherit

   POSIX_PERMISSIONS
      redefine
         status
      end

   PAPI_STAT
   
   PAPI_UNISTD


creation

   make


feature {POSIX_FILE_SYSTEM} -- creation
   
   make (a_status: POSIX_STATUS_PATH) is
      do
         status := a_status
         update_from_status
      end


feature {NONE}   

   
   apply_mode is
         -- make mode change permanent
      local
         r: INTEGER
      do
         r := posix_chmod (status.cpath, mode)
         if r = -1 then
            raise_posix_error
         end         
      end

   apply_owner_and_group is
         -- make owner and group change permanent
      local
         r: INTEGER
      do
         r := posix_chown (status.cpath, owner_id, group_id)
         if r = -1 then
            raise_posix_error
         end         
      end


feature {NONE}

   status: POSIX_STATUS_PATH
         -- used to be able to refresh itself
   

end -- class POSIX_PERMISSIONS_PATH
