indexing

	description: "Class that gets Posix stat structure through fstat call."

  author: "Berend de Boer"
	date: "$Date: Fri, 13 Oct 2000 13:36:48 +0200 $"
	revision: "$Revision: 1.5 $"

class 

   POSIX_STATUS_FILDES
   

inherit
   
   POSIX_STATUS


creation {BASE_FILE_DESCRIPTOR}
   
   make
   
   
feature -- creation

   make (a_fd: BASE_FILE_DESCRIPTOR) is
      require
         open_file_descriptor: a_fd.is_open
      do
         make_stat
         fd := a_fd
         refresh
      end

  
feature 
   
   refresh is
         -- Refresh the cached status information
      require else
         still_open: fd.is_open
      local
         r: INTEGER
      do
         r := posix_fstat (fd.value, stat.ptr)
         if r = -1 then
            raise_posix_error
         end
      end


feature -- stat members   
   
   permissions: POSIX_PERMISSIONS is
         -- file permissions
      do
         if my_permissions = Void then
            create {POSIX_PERMISSIONS_FILDES} my_permissions.make (Current)
         end
         Result := my_permissions
      end
   

feature -- state

   fd: BASE_FILE_DESCRIPTOR


feature {NONE} -- state

   my_permissions: POSIX_PERMISSIONS


invariant  
   
   valid_fd: fd /= Void

   
end -- class POSIX_STATUS_FILDES
